-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Grid - Real-Time Updates
The JavaScript DataGrid component is optimized for real-time updates. You should bind it to a DataSource that contains a store and use the push(changes) method to update the store's data. The rows with changed data are rerendered (see the JavaScript DataGrid's repaintChangesOnly property). The DataSource object also provides properties that control its behavior when it receives a push. For example, reshapeOnPush is set to true in this demo to allow summaries to be recalculated.
Backend API
$(() => {
$('#grid-container').dxDataGrid({
dataSource: {
store: productsStore,
reshapeOnPush: true,
},
repaintChangesOnly: true,
columnAutoWidth: true,
showBorders: true,
paging: {
pageSize: 10,
},
columns: [
{ dataField: 'ProductName', dataType: 'string' },
{ dataField: 'UnitPrice', dataType: 'number', format: 'currency' },
{ dataField: 'OrderCount', dataType: 'number' },
{ dataField: 'Quantity', dataType: 'number' },
{
dataField: 'Amount', dataType: 'number', format: 'currency', allowSorting: true,
},
],
summary: {
totalItems: [{
summaryType: 'count',
column: 'ProductName',
}, {
summaryType: 'sum',
displayFormat: '{0}',
valueFormat: 'currency',
column: 'Amount',
}, {
summaryType: 'sum',
displayFormat: '{0}',
column: 'OrderCount',
}],
},
masterDetail: {
enabled: true,
template(container, options) {
$('<div>').appendTo(container).dxDataGrid({
dataSource: {
store: ordersStore,
filter: ['ProductID', '=', options.key],
reshapeOnPush: true,
},
repaintChangesOnly: true,
columnAutoWidth: true,
showBorders: true,
paging: {
pageSize: 5,
},
columns: [{
dataField: 'OrderID',
dataType: 'number',
}, {
dataField: 'ShipCity',
dataType: 'string',
}, {
dataField: 'OrderDate',
dataType: 'datetime',
format: 'yyyy/MM/dd HH:mm:ss',
}, {
dataField: 'UnitPrice',
dataType: 'number',
}, {
dataField: 'Quantity',
dataType: 'number',
}, {
caption: 'Amount',
dataType: 'number',
format: 'currency',
allowSorting: true,
calculateCellValue(rowData) {
return rowData.UnitPrice * rowData.Quantity;
},
}],
summary: {
totalItems: [{
summaryType: 'count',
column: 'OrderID',
}, {
summaryType: 'sum',
displayFormat: '{0}',
column: 'Quantity',
}, {
summaryType: 'sum',
displayFormat: '{0}',
valueFormat: 'currency',
column: 'Amount',
}],
},
});
},
},
});
let updatesPerSecond = 100;
setInterval(() => {
if (orders.length > 500000) {
return;
}
for (let i = 0; i < updatesPerSecond / 20; i += 1) {
addOrder();
}
}, 50);
$('#frequency-slider').dxSlider({
min: 10,
max: 5000,
step: 10,
value: updatesPerSecond,
onValueChanged(e) {
updatesPerSecond = e.value;
},
tooltip: {
enabled: true,
showMode: 'always',
format: '#0 per second',
position: 'top',
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="grid-container"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Update frequency:</span>
<div id="frequency-slider"></div>
</div>
</div>
</div>
</body>
</html>
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
width: 500px;
display: inline-block;
vertical-align: middle;
}
const cities = ['Los Angeles', 'Denver', 'Bentonville', 'Atlanta', 'Reno', 'Beaver', 'Malibu', 'Phoenix', 'San Diego', 'Little Rock', 'Pasadena', 'Boise', 'San Jose', 'Chatsworth', 'San Fernando', 'South Pasadena', 'San Fernando Valley', 'La Canada', 'St. Louis'];
const orders = [];
const ordersStore = new DevExpress.data.ArrayStore({
key: 'OrderID',
data: orders,
});
const products = [];
for (let i = 1; i <= 100; i += 1) {
products.push({
ProductID: i, ProductName: `Product ${i}`, UnitPrice: Math.floor(Math.random() * 1000) + 1, Quantity: 0, Amount: 0, OrderCount: 0,
});
}
const productsStore = new DevExpress.data.ArrayStore({
key: 'ProductID',
data: products,
});
function addOrder() {
const product = products[Math.round(Math.random() * 99)];
const order = {
OrderID: orders.length ? orders[orders.length - 1].OrderID + 1 : 20001,
ShipCity: cities[Math.round(Math.random() * (cities.length - 1))],
ProductID: product.ProductID,
UnitPrice: product.UnitPrice,
OrderDate: new Date(),
Quantity: Math.round(Math.random() * 20) + 1,
};
ordersStore.push([{ type: 'insert', data: order }]);
productsStore.push([{
type: 'update',
key: order.ProductID,
data: {
OrderCount: product.OrderCount + 1,
Quantity: product.Quantity + order.Quantity,
Amount: product.Amount + order.UnitPrice * order.Quantity,
},
}]);
}
Grids in the detail sections are updated in real time as well. All the grids share the same ordersStore that receives pushes, but it is filtered to show only a specific product's orders for each grid.

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Data Grid - Real-Time Updates

The DataGrid component is optimized for real-time updates. You should bind it to a DataSource that contains a store and use the push(changes) method to update the store's data. The rows with changed data are rerendered (see the DataGrid's repaintChangesOnly property). The DataSource object also provides properties that control its behavior when it receives a push. For example, reshapeOnPush is set to true in this demo to allow summaries to be recalculated.

Backend API
import React, { useEffect, useState } from 'react'; import DataGrid, { Column, Summary, TotalItem, MasterDetail, Paging, } from 'devextreme-react/data-grid'; import type { DataGridTypes } from 'devextreme-react/data-grid'; import { Slider, Tooltip } from 'devextreme-react/slider'; import type { SliderTypes } from 'devextreme-react/slider'; import { DataSource } from 'devextreme-react/common/data'; import { productsStore, ordersStore, getOrderCount, addOrder, } from './data.ts'; import type { Product, Order } from './data.ts'; const dataSource = new DataSource({ store: productsStore, reshapeOnPush: true, }); const getDetailGridDataSource = (product: Product) => ({ store: ordersStore, reshapeOnPush: true, filter: ['ProductID', '=', product.ProductID], }); const getAmount = (order: Order) => order.UnitPrice * order.Quantity; const detailRender = (detail: DataGridTypes.MasterDetailTemplateData) => ( <DataGrid dataSource={getDetailGridDataSource(detail.data)} repaintChangesOnly={true} columnAutoWidth={true} showBorders={true}> <Paging defaultPageSize={5} /> <Column dataField="OrderID" dataType="number" /> <Column dataField="ShipCity" dataType="string" /> <Column dataField="OrderDate" dataType="datetime" format="yyyy/MM/dd HH:mm:ss" /> <Column dataField="UnitPrice" dataType="number" format="currency" /> <Column dataField="Quantity" dataType="number" /> <Column caption="Amount" dataType="number" format="currency" allowSorting={true} calculateCellValue={getAmount} /> <Summary> <TotalItem column="OrderID" summaryType="count" /> <TotalItem column="Quantity" summaryType="sum" displayFormat="{0}" /> <TotalItem column="Amount" summaryType="sum" displayFormat="{0}" valueFormat="currency" /> </Summary> </DataGrid> ); const App = () => { const [updateFrequency, setUpdateFrequency] = useState(100); useEffect(() => { const interval = setInterval(() => { if (getOrderCount() > 500000) { return; } for (let i = 0; i < updateFrequency / 20; i += 1) { addOrder(); } }, 50); return () => clearInterval(interval); }, [updateFrequency]); const onUpdateFrequencyChanged = (e: SliderTypes.ValueChangedEvent) => { setUpdateFrequency(e.value); }; return ( <div> <DataGrid dataSource={dataSource} repaintChangesOnly={true} columnAutoWidth={true} showBorders={true}> <Paging defaultPageSize={10} /> <Column dataField="ProductName" dataType="string" /> <Column dataField="UnitPrice" dataType="number" format="currency" /> <Column dataField="OrderCount" dataType="number" /> <Column dataField="Quantity" dataType="number" /> <Column dataField="Amount" dataType="number" format="currency" /> <Summary> <TotalItem column="ProductName" summaryType="count" /> <TotalItem column="Amount" summaryType="sum" displayFormat="{0}" valueFormat="currency" /> <TotalItem column="OrderCount" summaryType="sum" displayFormat="{0}" /> </Summary> <MasterDetail enabled={true} render={detailRender}> </MasterDetail> </DataGrid> <div className="options"> <div className="caption">Options</div> <div className="option"> <span>Update frequency:</span> <Slider min={10} step={10} max={5000} value={updateFrequency} onValueChanged={onUpdateFrequencyChanged}> <Tooltip enabled={true} format="#0 per second" showMode="always" position="top"> </Tooltip> </Slider> </div> </div> </div> ); }; export default App;
import React, { useEffect, useState } from 'react'; import DataGrid, { Column, Summary, TotalItem, MasterDetail, Paging, } from 'devextreme-react/data-grid'; import { Slider, Tooltip } from 'devextreme-react/slider'; import { DataSource } from 'devextreme-react/common/data'; import { productsStore, ordersStore, getOrderCount, addOrder, } from './data.js'; const dataSource = new DataSource({ store: productsStore, reshapeOnPush: true, }); const getDetailGridDataSource = (product) => ({ store: ordersStore, reshapeOnPush: true, filter: ['ProductID', '=', product.ProductID], }); const getAmount = (order) => order.UnitPrice * order.Quantity; const detailRender = (detail) => ( <DataGrid dataSource={getDetailGridDataSource(detail.data)} repaintChangesOnly={true} columnAutoWidth={true} showBorders={true} > <Paging defaultPageSize={5} /> <Column dataField="OrderID" dataType="number" /> <Column dataField="ShipCity" dataType="string" /> <Column dataField="OrderDate" dataType="datetime" format="yyyy/MM/dd HH:mm:ss" /> <Column dataField="UnitPrice" dataType="number" format="currency" /> <Column dataField="Quantity" dataType="number" /> <Column caption="Amount" dataType="number" format="currency" allowSorting={true} calculateCellValue={getAmount} /> <Summary> <TotalItem column="OrderID" summaryType="count" /> <TotalItem column="Quantity" summaryType="sum" displayFormat="{0}" /> <TotalItem column="Amount" summaryType="sum" displayFormat="{0}" valueFormat="currency" /> </Summary> </DataGrid> ); const App = () => { const [updateFrequency, setUpdateFrequency] = useState(100); useEffect(() => { const interval = setInterval(() => { if (getOrderCount() > 500000) { return; } for (let i = 0; i < updateFrequency / 20; i += 1) { addOrder(); } }, 50); return () => clearInterval(interval); }, [updateFrequency]); const onUpdateFrequencyChanged = (e) => { setUpdateFrequency(e.value); }; return ( <div> <DataGrid dataSource={dataSource} repaintChangesOnly={true} columnAutoWidth={true} showBorders={true} > <Paging defaultPageSize={10} /> <Column dataField="ProductName" dataType="string" /> <Column dataField="UnitPrice" dataType="number" format="currency" /> <Column dataField="OrderCount" dataType="number" /> <Column dataField="Quantity" dataType="number" /> <Column dataField="Amount" dataType="number" format="currency" /> <Summary> <TotalItem column="ProductName" summaryType="count" /> <TotalItem column="Amount" summaryType="sum" displayFormat="{0}" valueFormat="currency" /> <TotalItem column="OrderCount" summaryType="sum" displayFormat="{0}" /> </Summary> <MasterDetail enabled={true} render={detailRender} ></MasterDetail> </DataGrid> <div className="options"> <div className="caption">Options</div> <div className="option"> <span>Update frequency:</span> <Slider min={10} step={10} max={5000} value={updateFrequency} onValueChanged={onUpdateFrequencyChanged} > <Tooltip enabled={true} format="#0 per second" showMode="always" position="top" ></Tooltip> </Slider> </div> </div> </div> ); }; export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
import ArrayStore from 'devextreme/data/array_store'; const cities = ['Los Angeles', 'Denver', 'Bentonville', 'Atlanta', 'Reno', 'Beaver', 'Malibu', 'Phoenix', 'San Diego', 'Little Rock', 'Pasadena', 'Boise', 'San Jose', 'Chatsworth', 'San Fernando', 'South Pasadena', 'San Fernando Valley', 'La Canada', 'St. Louis']; export interface Order { OrderID: number; ShipCity: string; ProductID: number; UnitPrice: number; OrderDate: Date; Quantity: number; } const orders: Order[] = []; export interface Product { ProductID: number; ProductName: string; UnitPrice: number; Quantity: number; Amount: number; OrderCount: number; } const products: Product[] = []; for (let i = 1; i <= 100; i += 1) { products.push({ ProductID: i, ProductName: `Product ${i}`, UnitPrice: Math.floor(Math.random() * 1000) + 1, Quantity: 0, Amount: 0, OrderCount: 0, }); } export const productsStore = new ArrayStore({ key: 'ProductID', data: products, }); export const ordersStore = new ArrayStore({ key: 'OrderID', data: orders, }); export function getOrderCount() { return orders.length; } export function addOrder() { const product = products[Math.round(Math.random() * 99)]; const order = { OrderID: orders.length ? orders[orders.length - 1].OrderID + 1 : 20001, ShipCity: cities[Math.round(Math.random() * (cities.length - 1))], ProductID: product.ProductID, UnitPrice: product.UnitPrice, OrderDate: new Date(), Quantity: Math.round(Math.random() * 20) + 1, }; ordersStore.push([{ type: 'insert', data: order }]); productsStore.push([{ type: 'update', key: order.ProductID, data: { OrderCount: product.OrderCount + 1, Quantity: product.Quantity + order.Quantity, Amount: product.Amount + order.UnitPrice * order.Quantity, }, }]); }
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
import ArrayStore from 'devextreme/data/array_store'; const cities = [ 'Los Angeles', 'Denver', 'Bentonville', 'Atlanta', 'Reno', 'Beaver', 'Malibu', 'Phoenix', 'San Diego', 'Little Rock', 'Pasadena', 'Boise', 'San Jose', 'Chatsworth', 'San Fernando', 'South Pasadena', 'San Fernando Valley', 'La Canada', 'St. Louis', ]; const orders = []; const products = []; for (let i = 1; i <= 100; i += 1) { products.push({ ProductID: i, ProductName: `Product ${i}`, UnitPrice: Math.floor(Math.random() * 1000) + 1, Quantity: 0, Amount: 0, OrderCount: 0, }); } export const productsStore = new ArrayStore({ key: 'ProductID', data: products, }); export const ordersStore = new ArrayStore({ key: 'OrderID', data: orders, }); export function getOrderCount() { return orders.length; } export function addOrder() { const product = products[Math.round(Math.random() * 99)]; const order = { OrderID: orders.length ? orders[orders.length - 1].OrderID + 1 : 20001, ShipCity: cities[Math.round(Math.random() * (cities.length - 1))], ProductID: product.ProductID, UnitPrice: product.UnitPrice, OrderDate: new Date(), Quantity: Math.round(Math.random() * 20) + 1, }; ordersStore.push([{ type: 'insert', data: order }]); productsStore.push([ { type: 'update', key: order.ProductID, data: { OrderCount: product.OrderCount + 1, Quantity: product.Quantity + order.Quantity, Amount: product.Amount + order.UnitPrice * order.Quantity, }, }, ]); }
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
.options { padding: 20px; margin-top: 20px; background-color: rgba(191, 191, 191, 0.15); } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; display: flex; align-items: center; } .option > span { position: relative; top: 2px; margin-right: 10px; } .option > .dx-widget { width: 500px; display: inline-block; vertical-align: middle; }

Grids in the detail sections are updated in real time as well. All the grids share the same ordersStore that receives pushes, but it is filtered to show only a specific product's orders for each grid.

Backend API
<template>
<div>
<DxDataGrid
:data-source="productsDataSource"
:repaint-changes-only="true"
:two-way-binding-enabled="false"
:column-auto-width="true"
:show-borders="true"
>
<DxPaging :page-size="10"/>
<DxColumn
data-field="ProductName"
data-type="string"
/>
<DxColumn
data-field="UnitPrice"
data-type="number"
format="currency"
/>
<DxColumn
data-field="OrderCount"
data-type="number"
/>
<DxColumn
data-field="Quantity"
data-type="number"
/>
<DxColumn
data-field="Amount"
data-type="number"
format="currency"
/>
<DxSummary>
<DxTotalItem
column="ProductName"
summary-type="count"
/>
<DxTotalItem
column="Amount"
summary-type="sum"
display-format="{0}"
value-format="currency"
/>
<DxTotalItem
column="OrderCount"
summary-type="sum"
display-format="{0}"
/>
</DxSummary>
<DxMasterDetail
:enabled="true"
template="productDetail"
/>
<template #productDetail="{ data: detail }">
<DxDataGrid
:data-source="getDetailGridDataSource(detail.data)"
:column-auto-width="true"
:repaint-changes-only="true"
:two-way-binding-enabled="false"
:show-borders="true"
>
<DxPaging :page-size="5"/>
<DxColumn
data-field="OrderID"
data-type="number"
/>
<DxColumn
data-field="ShipCity"
data-type="string"
/>
<DxColumn
data-field="OrderDate"
data-type="datetime"
format="yyyy/MM/dd HH:mm:ss"
/>
<DxColumn
data-field="UnitPrice"
data-type="number"
format="currency"
/>
<DxColumn
data-field="Quantity"
data-type="number"
/>
<DxColumn
:allow-sorting="true"
:calculate-cell-value="getAmount"
caption="Amount"
format="currency"
data-type="number"
/>
<DxSummary>
<DxTotalItem
column="OrderID"
summary-type="count"
/>
<DxTotalItem
column="Quantity"
summary-type="sum"
display-format="{0}"
/>
<DxTotalItem
column="Amount"
summary-type="sum"
display-format="{0}"
value-format="currency"
/>
</DxSummary>
</DxDataGrid>
</template>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Update frequency:</span>
<DxSlider
:min="10"
:step="10"
:max="5000"
v-model:value="updatesPerSecond"
>
<DxTooltip
:enabled="true"
format="#0 per second"
show-mode="always"
position="top"
/>
</DxSlider>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { onMounted, onUnmounted, ref } from 'vue';
import {
DxDataGrid,
DxColumn,
DxSummary,
DxTotalItem,
DxMasterDetail,
DxPaging,
} from 'devextreme-vue/data-grid';
import { DxSlider, DxTooltip } from 'devextreme-vue/slider';
import {
productsStore, ordersStore, getOrderCount, addOrder, type Order, type Product,
} from './data.ts';
const updatesPerSecond = ref(100);
const productsDataSource = {
store: productsStore,
reshapeOnPush: true,
};
let interval: any;
onMounted(() => {
interval = setInterval(() => {
if (getOrderCount() > 500000) {
return;
}
for (let i = 0; i < updatesPerSecond.value / 20; i += 1) {
addOrder();
}
}, 50);
});
onUnmounted(() => {
clearInterval(interval);
});
const getDetailGridDataSource = (product: Product) => ({
store: ordersStore,
reshapeOnPush: true,
filter: ['ProductID', '=', product.ProductID],
});
const getAmount = (order: Order) => order.UnitPrice * order.Quantity;
</script>
<style scoped>
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
width: 500px;
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import ArrayStore from 'devextreme/data/array_store';
export type Product = {
ProductID: number;
ProductName: string;
UnitPrice: number;
Quantity: number;
Amount: number;
OrderCount: number;
};
export type Order = {
OrderID: number;
ShipCity: string;
ProductID: number;
UnitPrice: number;
OrderDate: Date;
Quantity: number;
};
const cities = ['Los Angeles', 'Denver', 'Bentonville', 'Atlanta', 'Reno', 'Beaver', 'Malibu', 'Phoenix', 'San Diego', 'Little Rock', 'Pasadena', 'Boise', 'San Jose', 'Chatsworth', 'San Fernando', 'South Pasadena', 'San Fernando Valley', 'La Canada', 'St. Louis'];
const orders: Order[] = [];
const products: Product[] = [];
for (let i = 1; i <= 100; i += 1) {
products.push({
ProductID: i,
ProductName: `Product ${i}`,
UnitPrice: Math.floor(Math.random() * 1000) + 1,
Quantity: 0,
Amount: 0,
OrderCount: 0,
});
}
export const productsStore = new ArrayStore<Product, number>({
key: 'ProductID',
data: products,
});
export const ordersStore = new ArrayStore<Order, number>({
key: 'OrderID',
data: orders,
});
export const getOrderCount = () => orders.length;
export const addOrder = () => {
const product = products[Math.round(Math.random() * 99)];
const order: Order = {
OrderID: orders.length ? orders[orders.length - 1].OrderID + 1 : 20001,
ShipCity: cities[Math.round(Math.random() * (cities.length - 1))],
ProductID: product.ProductID,
UnitPrice: product.UnitPrice,
OrderDate: new Date(),
Quantity: Math.round(Math.random() * 20) + 1,
};
ordersStore.push([{ type: 'insert', data: order }]);
productsStore.push([{
type: 'update',
key: order.ProductID,
data: {
OrderCount: product.OrderCount + 1,
Quantity: product.Quantity + order.Quantity,
Amount: product.Amount + order.UnitPrice * order.Quantity,
},
}]);
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
Grids in the detail sections are updated in real time as well. All the grids share the same ordersStore that receives pushes, but it is filtered to show only a specific product's orders for each grid.

Backend API
<dx-data-grid
id="orders"
[dataSource]="productsDataSource"
[repaintChangesOnly]="true"
[columnAutoWidth]="true"
[showBorders]="true"
>
<dxo-data-grid-paging [pageSize]="10"></dxo-data-grid-paging>
<dxi-data-grid-column
dataField="ProductName"
dataType="string"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="UnitPrice"
dataType="number"
format="currency"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="OrderCount"
dataType="number"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Quantity"
dataType="number"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Amount"
dataType="number"
format="currency"
[allowSorting]="true"
></dxi-data-grid-column>
<dxo-data-grid-summary>
<dxi-data-grid-total-item
column="ProductName"
summaryType="count"
></dxi-data-grid-total-item>
<dxi-data-grid-total-item
column="Amount"
summaryType="sum"
displayFormat="{0}"
valueFormat="currency"
></dxi-data-grid-total-item>
<dxi-data-grid-total-item
column="OrderCount"
summaryType="sum"
displayFormat="{0}"
></dxi-data-grid-total-item>
</dxo-data-grid-summary>
<dxo-data-grid-master-detail [enabled]="true" template="productDetail">
</dxo-data-grid-master-detail>
<div *dxTemplate="let detail of 'productDetail'">
<dx-data-grid
[dataSource]="getDetailGridDataSource(detail.data)"
[columnAutoWidth]="true"
[repaintChangesOnly]="true"
[showBorders]="true"
>
<dxo-data-grid-paging [pageSize]="5"></dxo-data-grid-paging>
<dxi-data-grid-column
dataField="OrderID"
dataType="number"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="ShipCity"
dataType="string"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="OrderDate"
dataType="datetime"
format="yyyy/MM/dd HH:mm:ss"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="UnitPrice"
dataType="number"
format="currency"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Quantity"
dataType="number"
></dxi-data-grid-column>
<dxi-data-grid-column
caption="Amount"
dataType="number"
format="currency"
[allowSorting]="true"
[calculateCellValue]="getAmount"
></dxi-data-grid-column>
<dxo-data-grid-summary>
<dxi-data-grid-total-item
column="OrderID"
summaryType="count"
></dxi-data-grid-total-item>
<dxi-data-grid-total-item
column="Quantity"
summaryType="sum"
displayFormat="{0}"
></dxi-data-grid-total-item>
<dxi-data-grid-total-item
column="Amount"
summaryType="sum"
displayFormat="{0}"
valueFormat="currency"
></dxi-data-grid-total-item>
</dxo-data-grid-summary>
</dx-data-grid>
</div>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Update frequency:</span>
<dx-slider [min]="10" [step]="10" [max]="5000" [(value)]="updatesPerSecond">
<dxo-slider-tooltip
[enabled]="true"
format="#0 per second"
showMode="always"
position="top"
>
</dxo-slider-tooltip>
</dx-slider>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ChangeDetectionStrategy, provideZoneChangeDetection } from '@angular/core';
import { DxDataGridModule, DxSliderModule } from 'devextreme-angular';
import { DataSource, ArrayStore } from 'devextreme-angular/common/data';
import { Product, Order, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
changeDetection: ChangeDetectionStrategy.OnPush,
imports: [
DxDataGridModule,
DxSliderModule,
],
})
export class AppComponent {
productsDataSource: DataSource;
orders: ArrayStore;
updatesPerSecond = 100;
constructor(service: Service) {
this.productsDataSource = new DataSource({
store: service.getProducts(),
reshapeOnPush: true,
});
this.orders = service.getOrders();
setInterval(() => {
if (service.getOrderCount() > 500000) {
return;
}
for (let i = 0; i < this.updatesPerSecond / 20; i += 1) {
service.addOrder();
}
}, 50);
}
getDetailGridDataSource(product: Product) {
return new DataSource({
store: this.orders,
reshapeOnPush: true,
filter: ['ProductID', '=', product.ProductID],
});
}
getAmount(order: Order) {
return order.UnitPrice * order.Quantity;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
width: 500px;
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
import { ArrayStore } from 'devextreme-angular/common/data';
export class Product {
ProductID: number;
ProductName: string;
UnitPrice: number;
Quantity: number;
Amount: number;
OrderCount: number;
}
export class Order {
OrderID: number;
ShipCity: string;
ProductID: number;
UnitPrice: number;
OrderDate: Date;
Quantity: number;
}
const cities = ['Los Angeles', 'Denver', 'Bentonville', 'Atlanta', 'Reno', 'Beaver', 'Malibu', 'Phoenix', 'San Diego', 'Little Rock', 'Pasadena', 'Boise', 'San Jose', 'Chatsworth', 'San Fernando', 'South Pasadena', 'San Fernando Valley', 'La Canada', 'St. Louis'];
const products: Product[] = [];
for (let i = 1; i <= 100; i += 1) {
products.push({
ProductID: i,
ProductName: `Product ${i}`,
UnitPrice: Math.floor(Math.random() * 1000) + 1,
Quantity: 0,
Amount: 0,
OrderCount: 0,
});
}
const productsStore = new ArrayStore({
data: products,
key: 'ProductID',
});
const orders: Order[] = [];
const ordersStore = new ArrayStore({
key: 'OrderID',
data: orders,
});
@Injectable()
export class Service {
getProducts() {
return productsStore;
}
getOrders() {
return ordersStore;
}
getOrderCount() {
return orders.length;
}
addOrder() {
const product = products[Math.round(Math.random() * 99)];
const order: Order = {
OrderID: orders.length ? orders[orders.length - 1].OrderID + 1 : 20001,
ShipCity: cities[Math.round(Math.random() * (cities.length - 1))],
ProductID: product.ProductID,
UnitPrice: product.UnitPrice,
OrderDate: new Date(),
Quantity: Math.round(Math.random() * 20) + 1,
};
ordersStore.push([{ type: 'insert', data: order }]);
productsStore.push([{
type: 'update',
key: order.ProductID,
data: {
OrderCount: product.OrderCount + 1,
Quantity: product.Quantity + order.Quantity,
Amount: product.Amount + order.UnitPrice * order.Quantity,
},
}]);
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Grids in the detail sections are updated in real time as well. All the grids share the same ordersStore that receives pushes, but it is filtered to show only a specific product's orders for each grid.